#ifndef	_mes_func_h_
#define	_mes_func_h_

typedef struct vb_data_s{
	OBJECT_IDENTIFIER_t oid;
	int vbv_present;
	int os_present;
	int st_present;
	OCTET_STRING_t value;
} vb_data_s;

typedef vb_data_s * vb_data_p;

typedef struct mesg_data{
	struct in_addr ip;
	long version;
	OCTET_STRING_t community;
	PDUs_PR	pdu_pr;
	int error_status;
	int error_index;
	int r_id;
	int vb_n;
	vb_data_p data;
} mesg_data;

typedef mesg_data * mesg_data_p;


typedef int 	ss_cr_func		__P((SS_Choice_t *pointer,OCTET_STRING_t *data));
typedef int 	ss_putrefy_func		__P((SS_Choice_t *pointer,OCTET_STRING_t *data));
typedef int	ss_cpv_func		__P((char *where,vb_data_p p));
typedef int	ss_free_func		__P((SS_Choice_t *pointer));

typedef int	os_cr_func		__P((OS_Choice_t *upointer,vb_data_p p));
typedef int	os_putrefy_func		__P((OS_Choice_t *upointer,vb_data_p p));
typedef int	os_cpv_func		__P((char *where,vb_data_p p));
typedef int	os_free_func		__P((OS_Choice_t *upointer));

typedef int	vbv_cr_func		__P((VBV_Choice_t *upointer,vb_data_p p));
typedef int	vbv_putrefy_func	__P((VBV_Choice_t *upointer,vb_data_p p));
typedef int	vbv_cpv_func		__P((char *where,vb_data_p p));
typedef int	vbv_free_func		__P((VBV_Choice_t *upointer));

typedef int	pdu_t_cr_func		__P((PDU_Choice_t *upointer,mesg_data_p p));
typedef int	pdu_t_putrefy_func	__P((PDU_Choice_t *upointer,mesg_data_p p));
typedef int	pdu_t_free_func		__P((PDU_Choice_t *upointer));

ss_cr_func		o_str_cr,oid_cr,int_cr;
ss_putrefy_func		o_str_putrefy,oid_putrefy,int_putrefy;
ss_cpv_func		int_cpv,o_str_cpv,oid_cpv;
ss_free_func		int_free,o_str_free,oid_free;

os_cr_func		sim_syn_cr;
os_putrefy_func		sim_syn_putrefy;
os_cpv_func		sim_syn_cpv;
os_free_func		sim_syn_free;

vbv_cr_func		obj_syn_cr,vbv_unspecified_cr;
vbv_putrefy_func	obj_syn_putrefy;
vbv_cpv_func		obj_syn_cpv,nothing_cpv;
vbv_free_func		obj_syn_free,vbv_unspecified_free;

pdu_t_cr_func   	set_request_cr,response_request_cr,get_request_cr,get_next_cr;
pdu_t_putrefy_func	set_request_putrefy,response_request_putrefy,get_request_putrefy,get_next_putrefy;
pdu_t_free_func		set_request_free,response_request_free,get_request_free,get_next_free;

int oid_create(OBJECT_IDENTIFIER_t *, const char *);
int oid_copy(OBJECT_IDENTIFIER_t *,const OBJECT_IDENTIFIER_t);
int os_copy(OCTET_STRING_t *,OCTET_STRING_t *);
int notintree(OBJECT_IDENTIFIER_t *, OBJECT_IDENTIFIER_t *);

int vbl_cr(VarBindList_t *,mesg_data_p);
int vbl_putrefy(VarBindList_t *,mesg_data_p);
int vbl_free(VarBindList_t *);
int vb_cr(VarBind_t *,vb_data_p);
int vb_putrefy(VarBind_t *,vb_data_p);
int vb_free(VarBind_t *);
int vbv_cr(VarBindValue_t *,vb_data_p);
int vbv_putrefy(VarBindValue_t *,vb_data_p);
int vbv_cpv(char *,vb_data_p);
int vbv_free(VarBindValue_t *);
int fill_mesg_data(PDUs_t *,mesg_data_p);
int putrefy_mesg_data(PDUs_t *,mesg_data_p);
int free_message_data(PDUs_t *);
int fill_mesg(Message_t *, mesg_data_p);
int putrefy_mesg(Message_t *, mesg_data_p);
int free_message(Message_t *);
int compare_oid (OBJECT_IDENTIFIER_t, OBJECT_IDENTIFIER_t);
int compare_vb_data (vb_data_p, vb_data_p, int);
int compare_mesg(mesg_data_p,mesg_data_p);

void free_mesg_data(mesg_data_p);
void free_vb_data(vb_data_p);

#endif
