#include "error.h"
#include "wrap.h"
#include "my_index.h"

/*Function to create index*/
my_index_p my_index_create(int max){
	my_index_p result;
	int i;

//	printf("Will be making an index\n");
	result=(my_index_p)Malloc(sizeof(my_index));
	result->max=max;
	result->root=(void **)Malloc(sizeof(void *)*max);
	for(i=0;i<max;i++){
//		printf("Trying to mark new-born pointers as free %i ",i);
		my_index_free_pointer(result,i);
	}
	return result;
}

/*Function to mark some pointer as a free to use */
int my_index_free_pointer(my_index_p index, int which){
	mi_fp_p result;
	
	result=(mi_fp_p)Malloc(sizeof(mi_fp));
	if (index->free==0) {
		result->pointer=&(index->root[which]);
		result->next=result;
		index->free=1;
	}
	else {
		result->pointer=&(index->root[which]);
		result->next=index->current_free->next;
		index->current_free->next=result;
		index->free++;
	}
	index->current_free=result->next;
	return 0;	
}



int my_index_add_to(my_index_p index, void * pointer){
	mi_fp_p taken;
	int i;
	
	if (index->free==0){
	    err_msg("need to add free slots to index");
	    index->root=Reallocf(index->root,index->max*sizeof(void *)*2);
	    for(i=0;i<index->max;i++){
		my_index_free_pointer(index,i+index->max);
	    }
	    index->max*=2;
	}
	taken=index->current_free->next;
	*(taken->pointer)=pointer;
	i=taken->pointer-index->root;
	if (index->free==1){
	    index->current_free=NULL;
	    index->free=0;
	    free(taken);
	}
	else{
	    index->current_free->next=taken->next;
	    index->free--;
	    free(taken);
	}
	return i;
}