#ifndef _protcli_h_
#define _protcli_h_

#define MAX_MSG 460


#define VBV_POSITION 0x000F
#define OS_POSITION 0x00F0
#define ST_POSITION 0x0F00
#define prepST_POSITION(x)   (((u_int32_t)(x) << 8) & ST_POSITION)
#define setST_POSITION(a,x)  {(a) &= ~ST_POSITION; (a) |= prepST_POSITION(x);}
#define getST_POSITION(a) (((a)>>8) & (ST_POSITION >> 8))
#define prepOS_POSITION(x)   (((u_int32_t)(x) << 4) & OS_POSITION)
#define setOS_POSITION(a,x)  {(a) &= ~OS_POSITION; (a) |= prepOS_POSITION(x);}
#define getOS_POSITION(a) (((a)>>4) & (OS_POSITION >> 4))
#define prepVBV_POSITION(x)   (((u_int32_t)(x)) & VBV_POSITION)
#define setVBV_POSITION(a,x)  {(a) &= ~VBV_POSITION; (a) |= prepVBV_POSITION(x);}
#define getVBV_POSITION(a) ((a) & (VBV_POSITION))

typedef struct message_global_variables{
	long version;
	OCTET_STRING_t community;
} mgv;

typedef mgv * mgvp;

mesg_data_p proceed_request(char * buff,int size,mgvp mgvp);
char *	    prepare_request(mesg_data_p pointer,int *size);
char *	    prepare_request_failure(int *size);

typedef struct client_variablebinder_header {
    int len;
    int flags;
    int oid_len;		
} cl_vb_hdr;

typedef cl_vb_hdr * cl_vb_hdr_p;

typedef struct client_message_header {
    int	len;
    struct in_addr ip;
    PDUs_PR pdu_pr;
    int vb_n;
    int error;
} cl_msg_hdr;

typedef cl_msg_hdr * cl_msg_hdr_p;

#endif