char *base_of_tree="1.3.6.1.2.1.17.7.1.4.3.1";
char *base_of_tree_ports="1.3.6.1.4.1.171.11.64.1.2.4.2.1";
char *base_of_port_security="1.3.6.1.4.1.171.11.64.1.2.14.1.1";
char *base_of_tree_fdb_st="1.3.6.1.2.1.17.7.1.3.1.1";
int name_suffix=1;
int egress_suffix=2;
int forbidden_suffix=3;
int untagged_suffix=4;
int init_suffix=5;
int port_index_suffix=1;
int port_state_suffix=3;
int port_speed_suffix=4;
int fdb_st_port_suffix=3;
int fdb_st_state_suffix=4;
int ps_mode=2;
int ps_max=3;
int ps_state=4;

int syslog_proc=0;
typedef struct switch_information {
	int 	num_ports;
	int	readonly;
	int     reconfigure;
	struct in_addr	ip;
	int	socket;
	mgvp	mygvp;
	OBJECT_IDENTIFIER_t	vlan_row_oid;
	OBJECT_IDENTIFIER_t	vlan_name_suffix;
	OBJECT_IDENTIFIER_t	vlan_egress_suffix;
	OBJECT_IDENTIFIER_t 	vlan_untagged_suffix;
	OBJECT_IDENTIFIER_t 	vlan_forbidden_suffix;
	OBJECT_IDENTIFIER_t	vlan_init_suffix;
	OBJECT_IDENTIFIER_t	vlan_untagged_ports;
	OBJECT_IDENTIFIER_t	port_row_oid;
	OBJECT_IDENTIFIER_t	port_index_suffix;
	OBJECT_IDENTIFIER_t	port_state_suffix;
	OBJECT_IDENTIFIER_t	port_speed_suffix;
	OBJECT_IDENTIFIER_t	fdb_st_row_oid;
	OBJECT_IDENTIFIER_t	fdb_st_port_suffix;
	OBJECT_IDENTIFIER_t	fdb_st_state_suffix;
} sw_inf;

typedef sw_inf * sw_inf_p;

typedef struct row_snmp_data_structure * row_snmp_data_p;

typedef struct row_snmp_data_structure {
	row_snmp_data_p		next;
	OBJECT_IDENTIFIER_t 	*suffix;
	vb_data_p		data;
} row_snmp_data_s;

typedef struct row_information_for_snmp {
	OBJECT_IDENTIFIER_t	*row_begin;
	OBJECT_IDENTIFIER_t 	tag_row_id;
	row_snmp_data_p		row_data;
} row_snmp_s;

typedef row_snmp_s * row_snmp_p;

typedef struct vlan_information_for_snmp {
	int			vid;
	int			flags;
	row_snmp_p		row;
} vl_snmp_s;

typedef vl_snmp_s * vl_snmp_p;

typedef struct port_information_for_snmp {
	int			port;
	int			flags;
	row_snmp_p		row;
} port_snmp_s;

typedef port_snmp_s * port_snmp_p;

typedef struct fdb_information_for_snmp {
	OBJECT_IDENTIFIER_t	*fdb;
	int			flags;
	row_snmp_p		row;	
} fdb_snmp_s;

typedef fdb_snmp_s * fdb_snmp_p;

 
typedef struct list_entry_str * list_entry_p;

typedef struct list_entry_str{
	void *	entry;
	int	type;
	int 	flags;
	list_entry_p	next;
} list_entry;

typedef list_entry_p * list_entry_p_base;

typedef list_entry_p c_p_read_f		__P((struct babolo_parm *,sw_inf_p,list_entry_p *));
c_p_read_f vlan_get,port_get,fdb_st_get;

typedef int c_p_comp_f			__P((void *, void *,int));
c_p_comp_f vlan_compare,port_compare,fdb_st_compare;

typedef list_entry_p c_p_get_f		__P((list_entry_p *, sw_inf_p, int * ));
c_p_get_f  vlan_get_cur,port_get_cur,fdb_st_get_cur;

typedef int c_p_cr_f			__P((list_entry_p, sw_inf_p));
c_p_cr_f   vlan_create,port_create,fdb_st_create;

typedef int c_p_del_f			__P((list_entry_p, sw_inf_p));
c_p_del_f  vlan_delete,port_delete,fdb_st_delete;

typedef int c_p_chk_f			__P((list_entry_p, list_entry_p, sw_inf_p));
c_p_chk_f  vlan_check,port_check,fdb_st_check;

typedef int c_p_post_f			__P((list_entry_p, sw_inf_p));
c_p_post_f vlan_untag;

enum {VLAN_ENTRY,PORT_ENTRY,FDB_ST_ENTRY,END_OF_LIST};

const struct config_parameter_handler {
	const char	*p_name;
	list_entry_p	(*c_p_read_f) __P((struct babolo_parm *,sw_inf_p,list_entry_p *));
	int		(*c_p_comp_f) __P((void *, void *,int ));
	list_entry_p	(*c_p_get_f)  __P((list_entry_p *, sw_inf_p ,int *));
	int 		(*c_p_cr_f)   __P((list_entry_p ,sw_inf_p));
	int		(*c_p_del_f)  __P((list_entry_p ,sw_inf_p));
	int		(*c_p_chk_f)  __P((list_entry_p, list_entry_p, sw_inf_p));
} par_hdlrs[] = {
	{"vlan",	vlan_get,	vlan_compare,	vlan_get_cur,	vlan_create,	vlan_delete,	vlan_check},
	{"port",	port_get,	port_compare,	port_get_cur,	port_create,	port_delete,	port_check},
	{"fdb",		fdb_st_get,	fdb_st_compare,	fdb_st_get_cur,	fdb_st_create,	fdb_st_delete,	fdb_st_check},
	{0,		NULL,		NULL,		NULL,		NULL,		NULL,		NULL},
};




typedef struct list_reference{
	list_entry_p_base	base;
	int			number;
	int			entries;
}l_ref;

#define NOT_PERFORM 1
#define DO_UNTAG    2

typedef l_ref * l_ref_p;

const struct post_functions_handler {
	const char	*p_name;
	int		type;
	int		flags_to_be_up;
	int		(*c_p_post_f) __P((list_entry_p, sw_inf_p));

} post_funcs[] = {
	{"vlan",	VLAN_ENTRY,	DO_UNTAG,	vlan_untag},
	{0,		NULL,		NULL,		NULL},	
};

